Attribute VB_Name = "CreateAnnotationSets_v1"
'--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'-------------------------------------------------CreateAnnotationSets_v1.0------------------------------------------------------------------------------------------------------
'Author:    Daniel Frauenrath
'Mail:      daniel.frauenrath@gmx.com
'Release:   27.10.2009
'Version:   1.0
'
'*************************************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<Beschreibung / Discription>>>>>>>>>>>>>>>>>>>>
'**************************************************************************************************************************************************************************
'
'DE:    Das Makro durchluft die Struktur eines vom Anwender selektierten geometrischen Set. Hierbei wird auf die erste Linie die Unterstruktur
'       eine Mittelpunkt erzeugt auf dem im Anschluss eine Annotation mit dem Namen des geometrischen Sets erzeugt wird
'
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'
'EN:
'
'*************************************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<Vernderungen / Change log>>>>>>>>>>>>>>>>>>>>
'**************************************************************************************************************************************************************************
'Autor:                 Datum:          Zeile/Line:     Modul / UserForm:       Anmerkung/Remark:
'--------------------------------------------------------------------------------------------------------------------------
'
'
'
'
'****************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<globale Variablen>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'****************************************************************************************************************************************************
    Public CreationCounter As Integer
'****************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<Hauptmakro>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'****************************************************************************************************************************************************
Sub CATMain()

'**********************************Deklarationen**********************************
    Dim iDoc As Document
    Dim ObjType As String
    Dim Box As String
    Dim SelAbfrageBox As VbMsgBoxResult
    Dim iPart As Part
    Dim iHybShapeFac As HybridShapeFactory
    Dim iHybBodies As HybridBodies
    Dim iHybBody As HybridBody
    Dim iHybShape As HybridShape
    Dim iAnnoSets As AnnotationSets
    Dim iAnnoSet As AnnotationSet
    Dim i As Integer
    Dim ii As Integer
    Dim iii As Integer
    Dim SelCleaner As Selection
    Dim myCurveObjects As New Collection
    Dim iSelection As Selection
    
'**********************************Nullsetzen von Variablen**********************************
    i = 0
    ii = 0
    iii = 0
    CreationCounter = 0

'**********************************Abfrage Dokumente**********************************
    Set iFenster = CATIA.Windows
    If iFenster.Count = 0 Then
        Box = MsgBox("Es ist kein Dokument geladen!" + Chr(10) + "Das Makro kann nicht ausgefhrt werden und wird beendet!", vbCritical, "Keine Dokument geladen")
        Exit Sub
    End If
    Set iDoc = CATIA.ActiveDocument
    ObjType = TypeName(iDoc)
    If ObjType <> "PartDocument" Then
        Box = MsgBox("Das aktive Dokument ist kein CATPart!" + Chr(10) + "Das Makro kann nicht ausgefhrt werden!", _
                vbCritical + vbOKOnly, "Falscher Dateityp")
        Exit Sub
    End If
    ObjType = ""

'**********************************UserSelektion**********************************
    Set iHybBody = UserSelection(iDoc)
    
'**********************************Arbeitsset instanzieren**********************************
    Do
        If iHybBody.HybridBodies.Count = 0 Then
            SelAbfrageBox = MsgBox("Das gewhlte geometrische Set besitzt keine Kinder" + Chr(10) + "Wollen Sie ein anderes geometrisches Set auswhlen?" + Chr(10) + Chr(10) + _
                                    Chr(34) + "NEIN" + Chr(34) + " beendet das Makro" + Chr(10) + Chr(34) + "JA" + Chr(34) + " wiederholt die Selektion", vbExclamtion + vbYesNo, _
                                    "Keine Kinder gefunden")
            If SelAbfrageBox = 7 Then 'vbCancel
                Set SelCleaner = iDoc.Selection
                SelCleaner.Clear
                Box = MsgBox("Das Makro wird beendet", vbInformation, "Makro wird beendet")
                Exit Sub
            Else
                Set iHybBody = UserSelection(iDoc)
            End If
        Else
            Exit Do
        End If
    Loop
    
'**********************************Geometrische Sets durchlaufen und Sets erstellen**********************************
    Set iPart = iDoc.Part
    Set iHybShapeFac = iPart.HybridShapeFactory
    For ii = 1 To iHybBody.HybridBodies.Count
        Set oHybShapes = iHybBody.HybridBodies.Item(ii).HybridShapes
        If oHybShapes.Count > 0 Then
            For iii = 1 To 1 '(ehem: "For iii = 1 To oHybShapes.Count") arbeitet jetzt nur noch mit der ersten Kurve. Knnte man schner machen, ich weiss.
                Set iHybShape = oHybShapes.Item(iii)
                If CheckTheType(iHybShape, iHybShapeFac) = True Then
                    Point_n_Annotation iHybShape, iHybBody.HybridBodies.Item(ii), iPart, iHybShapeFac
                    
                End If
            Next
        End If
    Next
    
'**********************************Umfaerben der Annotations**********************************
    CATIA.HSOSynchronized = False
    Set iSelection = iDoc.Selection

    iSelection.Search "((CATTPSSearch.CATTPSText + CATDrwSearch.DrwText) & Color='(0,0,0)'),all"
    iSelection.VisProperties.SetRealColor 255, 255, 255, 1
    CATIA.HSOSynchronized = True
'**********************************Ausgabe fr Anwender**********************************
    Dim M1 As String
    Dim M2 As String
    Dim Skin
    Dim Title As String
    
    M1 = "Das Makro wurde erfolgreich beendet"
    If CreationCounter = 0 Then
        M2 = "Es wurde kein Annotation Set erzeut"
    ElseIf CreationCounter = 1 Then
        M2 = "Es wurde ein Annotation Set erzeugt"
    ElseIf CreationCounter > 1 Then
        M2 = "Es wurden " & CreationCounter & " Annotation Sets erzeugt"
    End If
    
    Skin = vbInforamtion
    Title = "Makro erfolgreich beendet"
    
    Box = MsgBox(M1 + Chr(10) + Chr(10) + M2, Skin, Title)
        

End Sub

'****************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<UserSelektion>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'****************************************************************************************************************************************************
Private Function UserSelection(ByRef iDoc As Document) As HybridBody

'**********************************Deklarationen**********************************
    Dim iSel As Object ' As Selection
    Dim iType(0)
    Dim iUserSel As String

'**********************************Selektion und bergabe**********************************
    Set iSel = iDoc.Selection
    iSel.Clear
    Box = MsgBox("Bitte das geometrische Set auswhlen aus dem die Annotations erstellt werden sollen" + Chr(10) + "Drcken Sie ESC um die Selektion und das Makro abzubrechen" _
                , vbInformation, "Auswahl des geometrischen Sets")
    iType(0) = "HybridBody"
    iUserSel = iSel.SelectElement2(iType, "Bitte das geometrische Set auswhlen aus dem die Annotations erstellt werden sollen / ESC zum Abbrechen", True)
    If iUserSel <> "Normal" Then
        Box = MsgBox("Sie haben die Selektion abgebrochen" + Chr(10) + "Das Makro wird beendet" _
                    , vbExclamtion, "Abbruch der Selektion")
        End
    Else
        Set UserSelection = iSel.Item(1).Value
    End If
    
End Function


'****************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<Funktion zum Auslesen des Typs>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'****************************************************************************************************************************************************
Private Function CheckTheType(ByRef iHybShape As HybridShape, ByRef iHybShapeFac As HybridShapeFactory) As Boolean
    
'**********************************Deklarationen**********************************
    Dim myGeoFeatureType As Integer
    
'**********************************Typ auslesen und ggf. bergeben**********************************
    myGeoFeatureType = iHybShapeFac.GetGeometricalFeatureType(iHybShape)
    If myGeoFeatureType = 3 Or 5 Then  'Es ist eine Kurve oder ein Kreis
        CheckTheType = True
    Else
        CheckTheType = False
    End If
    
End Function

'****************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<Funktion zum Erstellen eines Referenzpunktes>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<und erzeugen der Annotation>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'****************************************************************************************************************************************************
Private Function Point_n_Annotation(ByRef iHybShape As HybridShape, ByRef iHybBody As HybridBody, ByRef iPart As Part, ByRef iHybShapeFac As HybridShapeFactory)

'***********Deklaration**********
Dim iRef As Reference
Dim iRefPlane As Reference
Dim iRefPlaneDirection As HybridShapeDirection
Dim iCheckpoint As HybridShapePointOnCurve
Dim iPoint As AnyObject
Dim connex As Boolean
Dim iSelection As Selection

'***********Connex Check***********
Set iRef = iPart.CreateReferenceFromObject(iHybShape)
Set iCheckpoint = iHybShapeFac.AddNewPointOnCurveFromPercent(iRef, 0.5, False)
iHybBody.AppendHybridShape iCheckpoint
iCheckpoint.Name = "Test4Connexity"
On Error Resume Next
iPart.Update
If Err.Number <> 0 Then
    connex = False
Else
    connex = True
    Set iSelection = CATIA.ActiveDocument.Selection
    iSelection.Clear
    iSelection.Add iCheckpoint
    iSelection.Delete
End If
On Error GoTo 0

'***********Punkt erstellen**********
If connex = True Then
    Set iRef = iPart.CreateReferenceFromObject(iHybShape)
    Set iPoint = iHybShapeFac.AddNewPointOnCurveFromPercent(iRef, 0.5, False)
Else
    Set iRef = iPart.CreateReferenceFromObject(iHybShape)
    Set iRefPlane = iPart.CreateReferenceFromObject(iPart.OriginElements.PlaneYZ)
    Set iRefPlaneDirection = iHybShapeFac.AddNewDirection(iRefPlane)
    Set iPoint = iHybridShapeFac.AddNewExtremum(iRef, iRefPlaneDirection, 1)
End If
iHybBody.AppendHybridShape iPoint
iPoint.Name = "Punkt_fuer_Annotation"

Set iSelection = CATIA.ActiveDocument.Selection
iSelection.Clear
iSelection.Add iPoint
iSelection.VisProperties.SetShow catVisPropertyNoShowAttr

'*********Erstellen der Annotation********
'Dimensionierung
Dim iAnnoSets As AnnotationSets
Dim iAnnoSet As AnnotationSet
Dim iUSerSurfaces As UserSurfaces
Dim iUserSurface As UserSurface
Dim iAnnoFac As AnnotationFactory
Dim myAnno As Annotation
Dim AnnotationText As String

'Deklaration
Set iAnnoSets = iPart.AnnotationSets
Set iAnnoSet = iAnnoSets.Add("ISO_3D")
Set iUSerSurfaces = iPart.UserSurfaces
Set iUserSurface = iUSerSurfaces.Generate(iRef)
Set iAnnoFac = iAnnoSet.AnnotationFactory

'Set erstellen
Set iAnnotationSets = iPart.AnnotationSets
Set iAnnoSet = iAnnoSets.Add("ISO_3D")
Set iUSerSurfaces = iPart.UserSurfaces
Set iUserSurface = iUsersurfeces.Generate(iRef)
Set iAnnoFac = iAnnoSet.AnnotationFactory

'Text generieren und zuweisen
Set myAnno = iAnnoFac.CreateEvoluateText(iUserSurface, 14, -35, 0, True)
AnnotationText = Replace(iHybBody.Name, "_", ".")
myAnno.Text.Text = AnnotationText
CreationCounter = CreationCounter + 1
iPart.Update
    
End Function




